
// Called from a mouse move this presents help messages for areas under
// the mouse pointer.

void Help_Message() {
  if (HelpOFF > 0) {return;}  // if >0 then help system is disabled

  Help$ = "-";         // clear current help message
  HelpRowPnt = -1;     // clear global row pointer
  int zAF = AngField;  // note previous value to trap update
  AngField = -1;       // reset angle field highlights
  rowColPnt = -1;      // reset column field highlights

  int zrowPnt = (getRowMYD() + rowPnt); zrowPnt = max(zrowPnt,0); zrowPnt = min(zrowPnt,rowNum-1);
  int zCP = zrowPnt * rowWidth;
  int CmdCode = ArrayVal[zCP + 1] ;  // get command type code
  int CmdVal0 = ArrayVal[zCP + 2] ;  // get command 1st value
  boolean CmdRowHlp = (ArrayVal[zCP] < 0);
  CmdRow = (ArrayVal[rowPnt * rowWidth] < 0);

  if ((mX >= 377) && (mX <= 446) && (mY < 36)) {Help$ = "Change App modes.";}

  if ((mY >= 13) && (mY <= 47)) {
    // top function buttons 1st row
         if ((mX >= 601) && (mX < 671)) {Help$ = "Insert 'REST' data.   L-click after. R-click before.  SHIFT-click send only.";}
    else if ((mX >= 671) && (mX < 741)) {Help$ = "Insert 'READY' data.   L-click after. R-click before.  SHIFT-click send only.";}
    else if ((mX >= 741) && (mX <= 810)) {Help$ = "Insert 'STAND' data.   L-click after. R-click before.  SHIFT-click send only.";}
  }
  else if ((mY >= 48) && (mY <= 82)) {
    // top function buttons 2nd row
         if ((mX >= 601) && (mX < 671)) {Help$ = "";}
    else if ((mX >= 671) && (mX < 741)) {Help$ = "";}
    else if ((mX >= 741) && (mX <= 810)) {Help$ = "Insert 'SQUAT' data.   L-click after. R-click before.  SHIFT-click send only.";}
  }

  //#####################################################################
  //
  // Screen specific help functions
  //
  //#####################################################################
  if (Scrn == 0) {Help_Message_0();}
  else if (Scrn == 1) {Help_Message_1();}
  else {Help_Message_2();}
  if (rowColPnt >= 0) {drawFlag = 1;}
  //Help$ = str(rowColPnt);

  //#####################################################################
  //
  // All lower screen help functions
  //
  //#####################################################################
  if ((mY >= 547) && (mY <= 686)) {
    // Memory lines, sliders and buttons
    if ((SelCnt > 0) && (mX <= 105)) {
      // left-hand side buttons and arrows
      if (mY <= 580) {
        // left region top row
        if ((mX >= 72) && (mX <= 102)) {Help$ = "Move " + str(SelCnt) + " selected rows up.";}
      } else if (mY <= 616) {
        // left region 2nd row
        if (mX < 39) {Help$ = "Copy and cut " + str(SelCnt) + " selected rows.";}
        if ((mX >= 39) && (mX < 72)) {Help$ = "Copy " + str(SelCnt) + " selected rows.";}
      } else if (mY <= 650) {
        // left region 3rd row
        if ((mX >= 9) && (mX < 39)) {
          if ((CmdRowHlp) && (CmdType == 1)) {
            Help$ = "Overwrite a GOTO branch, to a selected row.";
          } else {
            Help$ = "Insert a GOTO branch, to a selected row.";
          }
        }
             if ((mX >= 39) && (mX < 71)) {Help$ = "Calculate steps for " + str(SelCnt) + " selected rows.  SHIFT-click to reset selected.";}
        else if ((mX >= 71) && (mX <= 102)) {Help$ = "Transpose " + str(SelCnt) + " selected row angles.";}
      } else {
        // left region 4th row
        if ((mX >= 39) && (mX < 71)) {
          if (SelCnt < 2) {
            Help$ = "Reverse selected row order. INACTIVE - too few selected.";
          } else {
            Help$ = "Reverse the order of " + str(SelCnt) + " selected rows.";
          }
        }
        if ((mX >= 71) && (mX <= 102)) {Help$ = "Move " + str(SelCnt) + " selected rows down.";}
      }
    }
    if (CopyCnt > 0) {  
      if ((mY > 575) && (mY < 614)) {  
        if ((mX >= 71) && (mX <= 102)) {Help$ = "Paste " + str(CopyCnt) + " copied rows.";}
      }  
    }
    if ((mX >= 585) && (mX <= 611)) {
      // vertical slider region
           if (mY < 566) {Help$ = "Decrement current row pointer.";}
      else if ((mY >= 566) && (mY < 589)) {Help$ = "Go to first row.";}
      else if ((mY >= 642) && (mY < 665)) {Help$ = "Go to last row.";}
      else if (mY >= 665) {Help$ = "Increment current row pointer.";}
    }
    if ((mX >= 614) && (mX <= 643)) {
      //R-hand insert buttons Blank,Delete,Pause,Balance
           if (mY < 576) {Help$ = "Insert a blank row. L-click after. R-click before.";}
      else if ((mY >= 578) && (mY < 613)) {
        if (SelCnt < 1) {Help$ = "Delete current row.";}
        else {Help$ = "Delete all selected rows.";}
      }
      else if ((mY >= 616) && (mY < 651)) {Help$ = "Insert a Pause. L-click after. R-click before.";}
      else if ((mY >= 653) && (mY < 689)) {Help$ = "Insert a Balance. L-click after. R-click before.";}
    }
    if ((mX >= 646) && (mX <= 675)) {
      //R-hand insert buttons Speed,New,Flag,TBD
           if (mY < 576) {
             if ((Cmd) && (CmdType == 2)) {
               Help$ = "Click to change 'Speed' command.";
             } else {
               Help$ = "Insert a 'Speed' command. L-click after. R-click before.";
             }
           }
      else if ((mY >= 587) && (mY <= 614)) {Help$ = "Add duplicate row. L-click after. R-click before. SHIFT-click intermediate.";}
      else if ((mY >= 616) && (mY <= 651)) {Help$ = "Insert a 'Flag' value. L-click after. R-click before.";}
      else if ((mY >= 653) && (mY <= 689)) {Help$ = "Insert an excuteable code. L-click after. R-click before.";}
    }
    if ((mY >= 559) && (mY <= 595)) {
      // Memory buttons top row
           if ((mX >= 691) && (mX < 719)) {Help$ = "M0 store. Click to recall. Click-hold to store data.";}
      else if ((mX >= 719) && (mX < 749)) {Help$ = "M1 store. Click to recall. Click-hold to store data.";}
      else if ((mX >= 749) && (mX < 778)) {Help$ = "M2 store. Click to recall. Click-hold to store data.";}
      else if ((mX >= 778) && (mX <= 807)) {Help$ = "M3 store. Click to recall. Click-hold to store data.";}
    }
    if ((mY >= 598) && (mY <= 633)) {
      // Play buttons 2nd row
      if (usbEn || (Scrn == 2)) {
             if ((mX >= 691) && (mX < 719)) {Help$ = "PLAY memory contents once.";}
        else if ((mX >= 719) && (mX < 749)) {Help$ = "PLAY memory contents repeatedly.";}
        else if ((mX >= 749) && (mX < 778)) {Help$ = "PAUSE playing.";}
        else if ((mX >= 778) && (mX <= 807)) {Help$ = "STOP playing.";}
      }  
    }
    if ((mY >= 636) && (mY <= 671)) {
      // 3rd row buttons - Clear,Copy,Paste
           if ((mX >= 691) && (mX < 749)) {Help$ = "Click-hold to clear memory contents.";}
      else if ((mX >= 749) && (mX < 778)) {Help$ = "Copy memory contents to clipboard.";}
      else if ((mX >= 778) && (mX < 807)) {Help$ = "Click-hold to paste clipboard contents into memory.";}
    }
  }

  //#####################################################################
  //
  // list lines region
  //
  //#####################################################################
  int zmY = 547; if (Scrn == 1) {zmY = 41;}
  if ((mY >= zmY) && (mY <= 686)) {
    if ((mX >= 105) && (mX < 582)) {
      // memory lines region, list window
      int zR = getRowMYD() + rowPnt;
      if ((zR >= 0) && (zR < rowNum)) {
        HelpRowPnt = zR; drawFlag = 1; // global pointer for current mouse row
        if ((mX >= 105) && (mX < 138)) {Help$ = "Select this row.  SHIFT+click to select a range.";}
        if (!CmdRowHlp) {
          if ((mX >= 154) && (mX < 494)) {
                AngField = getAngleMXD();
                if (zAF != AngField) {drawFlag = 1;}  // only redraw if a change has occured
                Help$ = "Servo angles. Click-L increase / Click-R decrease.";
            if ((mY >= 604) && (mY <= 626)) {
                // centre row
                //AngField = getAngleMXD(); HelpLast$ = "";
                Help$ = "Current memory row.";
                if (usbEn) {Help$ += " SHIFT L-click to send data.";}
                else {Help$ += " SHIFT+L/R-click to copy/paste data.";}
            }
          }
          if ((mX >= 512) && (mX < 537)) {
            switch(getProfile(getRowMYD() + rowPnt)) {
              case 0: Help$ = "Constant"; break;
              case 1: Help$ = "Accelerate"; break;
              case 2: Help$ = "Decelerate"; break;
              case 3: Help$ = "Switch A/D"; break;
            }
            Help$ += " rate profile. Click L/R to change. Click+hold to reset ALL.";
          }
          if ((mX >= 543) && (mX < 582)) {Help$ = "Steps value. L-click increase. R-click decrease. Shift-click calculate.";}
        } else {
          // command line
          if (CmdCode < 6) {Help$ = "Command: ";} else {Help$ = "Execute: ";}
               if (CmdCode == 0) {Help$ = "Blank line";}
          else if (CmdCode == 1) {Help$ += "Goto row " + str(CmdVal0);}
          else if (CmdCode == 2) {Help$ += "Set speed to " + str(CmdVal0) + ". L-click increase. R-click decrease.";}
          else if (CmdCode == 3) {Help$ += "Set pause to " + str(CmdVal0) + ". L-click increase. R-click decrease.";}
          else if (CmdCode == 4) {Help$ += "Set Flag to " + str(CmdVal0) + ". L-click increase. R-click decrease.";}
          else if (CmdCode == 5) {
            Help$ += "Set Balance to ";
            if (CmdVal0 == 0) {Help$ +=  "OFF";}
            else {Help$ +=  "ON";}
            Help$ +=  ". Click to toggle ON/OFF.";
          }
          else if (CmdCode == 6) {Help$ += "For...1 to ..." + str(CmdVal0) + " loop.  L-click increase. R-click decrease.";}
          else if (CmdCode == 7) {Help$ += "Next after a For... loop.  L-click increase. R-click decrease.";}
        }
      }
    }
  }
  
  if ((mY >= 703) && (mY < 741)) {
    // Processing logo
    if ((mX >= 12) && (mX <= 49)) {Help$ = "App written in 'Processing'.   Visit: https://processing.org/";}
  }
  if ((mY >= 690) && (mY < 716)) {
    // Com, RX, Tx fields
    if ((mX >= 105) && (mX <= 180)) {
      if (comFlag < 1) {Help$ = "USB port is disconnected. Left-click to connect.";}
      else {Help$ = "USB port is connected. Right-click to disconnect.";}
    }
    if ((mX >= 217) && (mX <= 440)) {Help$ = "Messages received from USB port.";}
    if ((mX >= 478) && (mX <= 682)) {
      Help$ = "Messages sent to the USB port - ";  
      if (usbEn) {Help$ += "ENABLED";} else {Help$ += "DISABLED";}
    }
    if ((mX >= 694) && (mX <= 712)) {Help$ = "USB activity data lamp";}
  }
  if ((mY >= 686) && (mY <= 721)) {
    // Echo button
    if ((mX >= 749) && (mX <= 807)) {Help$ = "Echo function. Click to toggle Arduino responses ON/OFF.";}
  }
  if ((mY >= 724) && (mY <= 748)) {
    // Help field & TechKnowTone
         if ((mX >= 106) && (mX <= 682)) {Help$ = "Hello";}
    else if ((mX >= 712) && (mX <= 807)) {Help$ = "Author: TechKnowTone     Released: " + Released$;}
  }
  
  if (!Help$.equals(HelpLast$)) {
    // string is new so display it and remember it
    HelpLast$ = Help$; drawFlag = 1;
  }
  
}

// ----------------------------------------------------------------------

void Help_Message_0() {
  // display help messages for Scrn0
  if (CmdRow) {
    // command so make top part of form inactive
  } else {
    // not a command line so display help messages

    if ((mY >= 122) && (mY < 148)) {
        // Level 3 text fields & links
             if ((mX >= 148) && (mX < 160)) {Help$ = "Increment shoulder FR3 value.";}
        else if ((mX >= 160) && (mX < 186)) {Help$ = "Shoulder FR3 value. Click-n-drag to change.";}
        else if ((mX >= 186) && (mX < 198)) {Help$ = "Decrement shoulder FR3 value.";}
  
        else if ((mX >= 198) && (mX < 215)) {Help$ = "Click to set FR3 as FL3.";}
        else if ((mX >= 215) && (mX < 233)) {Help$ = "Link changes to FR3 and FL3 values.";}
        else if ((mX >= 233) && (mX < 250)) {Help$ = "Click to set FL3 as FR3.";}
  
        else if ((mX >= 250) && (mX < 262)) {Help$ = "Increment shoulder FL3 value.";}
        else if ((mX >= 262) && (mX <= 287)) {Help$ = "Shoulder FL3 value. Click-n-drag to change.";}
        else if ((mX > 287) && (mX <= 299)) {Help$ = "Decrement shoulder FL3 value.";}
  
        else if ((mX >= 376) && (mX < 388)) {Help$ = "Increment shoulder RR3 value.";}
        else if ((mX >= 388) && (mX <= 413)) {Help$ = "Shoulder RR3 value. Click-n-drag to change.";}
        else if ((mX > 413) && (mX <= 425)) {Help$ = "Decrement shoulder RR3 value.";}
  
        else if ((mX >= 425) && (mX < 441)) {Help$ = "Set RR3 as RL3.";}
        else if ((mX >= 441) && (mX < 459)) {Help$ = "Link changes to RR3 and RL3 values.";}
        else if ((mX >= 459) && (mX < 476)) {Help$ = "Set RL3 as RR3.";}
  
        else if ((mX >= 476) && (mX < 488)) {Help$ = "Increment shoulder RL3 value.";}
        else if ((mX >= 488) && (mX <= 514)) {Help$ = "Shoulder RL3 value. Click-n-drag to change.";}
        else if ((mX > 514) && (mX <= 526)) {Help$ = "Decrement shoulder RL3 value.";}
    
             if ((mX >= 148) && (mX < 198)) {rowColPnt = 2;}  // FR3
        else if ((mX >= 250) && (mX < 299)) {rowColPnt = 5;}  // FL3
        else if ((mX >= 376) && (mX < 425)) {rowColPnt = 8;}  // RR3
        else if ((mX >= 476) && (mX < 526)) {rowColPnt = 11;} // RL3
        
    } else if ((mY >= 148) && (mY <= 168)) {
        // Level 3 transposes & Pwr buttons
        if ((mX >= 165) && (mX <= 182)) {Help$ = "Toggle FR3 servo power. Hold to toggle all.";}
        else if ((mX >= 183) && (mX <= 198)) {Help$ = "Toggle FR3 auto-rate mode.";}
        else if ((mX >= 213) && (mX < 234)) {Help$ = "Transpose FR3/Ch5 with FL3/Ch4 angles";}
        else if ((mX >= 266) && (mX <= 284)) {Help$ = "Toggle FL3 servo power. Hold to toggle all.";}
        else if ((mX >= 285) && (mX <= 299)) {Help$ = "Toggle FL3 auto-rate mode.";}
        else if ((mX >= 391) && (mX <= 409)) {Help$ = "Toggle RR3 servo power. Hold to toggle all.";}
        else if ((mX >= 410) && (mX <= 425)) {Help$ = "Toggle RR3 auto-rate mode.";}
        else if ((mX >= 439) && (mX < 461)) {Help$ = "Transpose RR3/Ch10 with RL3/Ch11 angles";}
        else if ((mX >= 492) && (mX <= 510)) {Help$ = "Toggle RL3 servo power. Hold to toggle all.";}
        else if ((mX >= 510) && (mX <= 526)) {Help$ = "Toggle RL3 auto-rate mode.";}

    
    } else if ((mY >= 260) && (mY < 286)) {
        // Level 2 text fields & links
        if ((mX >= 174) && (mX < 186)) {Help$ = "Increment upper leg FR2 value.";}
        else if ((mX >= 186) && (mX <= 211)) {Help$ = "Upper leg FR2 value. Click-n-drag to change.";}
        else if ((mX > 211) && (mX <= 223)) {Help$ = "Decrement upper leg FR2 value.";}
  
        else if ((mX >= 223) && (mX < 240)) {Help$ = "Set FR2 as FL2.";}
        else if ((mX >= 240) && (mX < 258)) {Help$ = "Link changes to FR2 and FL2 values.";}
        else if ((mX >= 258) && (mX < 275)) {Help$ = "Set FL2 as FR2.";}
  
        else if ((mX >= 275) && (mX < 287)) {Help$ = "Increment upper leg FL2 value.";}
        else if ((mX >= 287) && (mX <= 312)) {Help$ = "Upper leg FL2 value. Click-n-drag to change.";}
        else if ((mX > 312) && (mX <= 324)) {Help$ = "Decrement upper leg FL2 value.";}
  
        else if ((mX >= 400) && (mX < 412)) {Help$ = "Increment upper leg RR2 value.";}
        else if ((mX >= 412) && (mX <= 438)) {Help$ = "Upper leg RR2 value. Click-n-drag to change.";}
        else if ((mX > 438) && (mX <= 450)) {Help$ = "Decrement upper leg RR2 value.";}
  
        else if ((mX >= 450) && (mX < 467)) {Help$ = "Set RR2 as RL2.";}
        else if ((mX >= 467) && (mX < 485)) {Help$ = "Link changes to RR2 and RL2 values.";}
        else if ((mX >= 485) && (mX < 501)) {Help$ = "Set RL2 as RR2.";}
  
        else if ((mX >= 501) && (mX < 513)) {Help$ = "Increment upper leg RL2 value.";}
        else if ((mX >= 513) && (mX <= 539)) {Help$ = "Upper leg RL2 value. Click-n-drag to change.";}
        else if ((mX > 539) && (mX <= 551)) {Help$ = "Decrement upper leg RL2 value.";}
    
             if ((mX >= 174) && (mX < 223)) {rowColPnt = 1;}  // FR2
        else if ((mX >= 275) && (mX < 324)) {rowColPnt = 4;}  // FL2
        else if ((mX >= 400) && (mX < 450)) {rowColPnt = 7;}  // RR2
        else if ((mX >= 501) && (mX < 551)) {rowColPnt = 10;} // RL2
    
     } else if ((mY >= 286) && (mY <= 305)) {
        // Level 2 transposes & Pwr buttons
        if ((mX >= 174) && (mX <= 188)) {Help$ = "Toggle FR2 auto-rate mode.";}
        else if ((mX >= 189) && (mX <= 206)) {Help$ = "Toggle FR2 servo power. Hold to toggle all.";}
        else if ((mX >= 238) && (mX < 258)) {Help$ = "Transpose FR2/Ch3 with FL2/Ch2 angles";}
        else if ((mX >= 275) && (mX <= 289)) {Help$ = "Toggle FL2 auto-rate mode.";}
        else if ((mX >= 290) && (mX <= 308)) {Help$ = "Toggle FL2 servo power. Hold to toggle all.";}
        else if ((mX >= 400) && (mX <= 415)) {Help$ = "Toggle RR2 auto-rate mode.";}
        else if ((mX >= 416) && (mX <= 434)) {Help$ = "Toggle RR2 servo power. Hold to toggle all.";}
        else if ((mX >= 465) && (mX < 485)) {Help$ = "Transpose RR2/Ch12 with RL2/Ch13 angles";}
        else if ((mX >= 500) && (mX <= 516)) {Help$ = "Toggle RL2 auto-rate mode.";}
        else if ((mX >= 517) && (mX <= 535)) {Help$ = "Toggle RL2 servo power. Hold to toggle all.";}
   
     } else if ((mY >= 385) && (mY < 411)) {
        // Level 1 text fields & links
        if ((mX >= 286) && (mX < 298)) {Help$ = "Decrement upper leg FR1 value.";}
        else if ((mX >= 298) && (mX <= 323)) {Help$ = "Lower leg FR1 value. Click-n-drag to change.";}
        else if ((mX > 323) && (mX <= 335)) {Help$ = "Increment upper leg FR1 value.";}
  
        else if ((mX >= 335) && (mX < 352)) {Help$ = "Set FR1 as FL1.";}
        else if ((mX >= 352) && (mX < 370)) {Help$ = "Link changes to FR1 and FL1 values.";}
        else if ((mX >= 370) && (mX < 385)) {Help$ = "Set FL1 as FR1.";}
  
        else if ((mX >= 385) && (mX < 397)) {Help$ = "Decrement upper leg FL1 value.";}
        else if ((mX >= 397) && (mX <= 422)) {Help$ = "Lower leg FL1 value. Click-n-drag to change.";}
        else if ((mX > 422) && (mX <= 434)) {Help$ = "Increment upper leg FL1 value.";}
  
        else if ((mX >= 512) && (mX < 524)) {Help$ = "Decrement upper leg RR1 value.";}
        else if ((mX >= 524) && (mX <= 549)) {Help$ = "Lower leg RR1 value. Click-n-drag to change.";}
        else if ((mX > 549) && (mX <= 561)) {Help$ = "Increment upper leg RR1 value.";}
  
        else if ((mX >= 561) && (mX < 578)) {Help$ = "Set RR1 as RL1.";}
        else if ((mX >= 578) && (mX < 596)) {Help$ = "Link changes to RR1 and RL1 values.";}
        else if ((mX >= 596) && (mX < 612)) {Help$ = "Set RL1 as RR1.";}
  
        else if ((mX >= 612) && (mX < 624)) {Help$ = "Decrement upper leg RL1 value.";}
        else if ((mX >= 624) && (mX <= 649)) {Help$ = "Lower leg RL1 value. Click-n-drag to change.";}
        else if ((mX > 649) && (mX <= 661)) {Help$ = "Increment upper leg RL1 value.";}
    
             if ((mX >= 286) && (mX < 335)) {rowColPnt = 0;}  // FR1
        else if ((mX >= 385) && (mX < 434)) {rowColPnt = 3;}  // FL1
        else if ((mX >= 512) && (mX < 561)) {rowColPnt = 6;}  // RR1
        else if ((mX >= 612) && (mX < 661)) {rowColPnt = 9;} // RL1
   
    } else if ((mY >= 411) && (mY <= 430)) {
        // Level 1 transposes & Pwr buttons
        if ((mX >= 286) && (mX <= 300)) {Help$ = "Toggle FR1 auto-rate mode.";}
        else if ((mX >= 301) && (mX <= 320)) {Help$ = "Toggle FR1 servo power. Hold to toggle all.";}
        else if ((mX >= 350) && (mX < 370)) {Help$ = "Transpose FR1/Ch1 with FL1/Ch0 angles";}
        else if ((mX >= 385) && (mX <= 400)) {Help$ = "Toggle FL1 auto-rate mode.";}
        else if ((mX >= 401) && (mX <= 419)) {Help$ = "Toggle FL1 servo power. Hold to toggle all.";}
        else if ((mX >= 511) && (mX <= 526)) {Help$ = "Toggle RR1 auto-rate mode.";}
        else if ((mX >= 527) && (mX <= 546)) {Help$ = "Click to toggle RR1 servo power. Hold to toggle all.";}
        else if ((mX >= 576) && (mX < 596)) {Help$ = "Transpose RR1/Ch14 with RL1/Ch15 angles";}
        else if ((mX >= 612) && (mX <= 627)) {Help$ = "Toggle RL1 auto-rate mode.";}
        else if ((mX >= 628) && (mX <= 646)) {Help$ = "Toggle RL1 servo power. Hold to toggle all.";}
     }
   }
  
  if ((mY >= 488) && (mY <= 545)) {
    // Multimove controls
         if ((mX >= 222) && (mX < 277)) {Help$ = "FR Multi-move handle control.";}
    else if ((mX >= 324) && (mX < 380)) {Help$ = "FL Multi-move handle control.";}
    else if ((mX >= 450) && (mX < 504)) {Help$ = "RR Multi-move handle control.";}
    else if ((mX >= 551) && (mX < 607)) {Help$ = "RL Multi-move handle control.";}
  }
  
  if ((mY >= 515) && (mY <= 539)) {
    // Degrees/step field
         if ((mX >= 12) && (mX < 31)) {Help$ = "Decrement Degrees/Step value.";}
    else if ((mX >= 31) && (mX < 81)) {Help$ = "Degrees/Step value used in step calcs. Click to reset.";}
    else if ((mX >= 81) && (mX <= 99)) {Help$ = "Increment Degrees/Step value.";}
    // Speed buttons and field
         if ((mX >= 722) && (mX < 740)) {Help$ = "Decrement Speed value.";}
    else if ((mX >= 740) && (mX < 791)) {Help$ = "Speed value (steps/sec). Click to reset to default.";}
    else if ((mX >= 791) && (mX <= 809)) {Help$ = "Increment Speed value.";}
  }
}

// ----------------------------------------------------------------------

void Help_Message_1() {
  // display help messages for Scrn1
  if (!CmdRow) {
    // not a command so do this
    if ((mY >= 184) && (mY <= 436)) {
      // RoboDog image servo identification.
      // Maps image srvos to current row columns
      if (mY <= 216) {
        // Tier 3 servos
        if ((mX >= 599) && (mX <= 639)) {rowColPnt =  2; return;}  // FR3
        if ((mX >= 641) && (mX <= 677)) {rowColPnt =  8; return;}  // RR3
        if ((mX >= 706) && (mX <= 742)) {rowColPnt =  5; return;}  // FL3
        if ((mX >= 746) && (mX <= 784)) {rowColPnt = 11; return;}  // RL3
      }
      else if ((mY >= 233) && (mY < 289)) {
        // Tier 2 servos
        if ((mX >= 599) && (mX <= 639)) {rowColPnt =  1; return;}  // FR2
        if ((mX >= 641) && (mX <= 677)) {rowColPnt =  7; return;}  // RR2
        if ((mX >= 706) && (mX <= 742)) {rowColPnt =  4; return;}  // FL2
        if ((mX >= 746) && (mX <= 784)) {rowColPnt = 10; return;}  // RL2
      }
      else if ((mY >= 289) && (mY <= 335)) {
        // Tier 1 servos
        if ((mX >= 599) && (mX <= 639)) {rowColPnt =  0; return;}  // FR1
        if ((mX >= 641) && (mX <= 677)) {rowColPnt =  6; return;}  // RR1
        if ((mX >= 706) && (mX <= 742)) {rowColPnt =  3; return;}  // FL1
        if ((mX >= 746) && (mX <= 784)) {rowColPnt =  9; return;}  // RL1
      }
    }
  }
  
  if ((mY >= 515) && (mY <= 539)) {
    // Degrees/step field
         if ((mX >= 12) && (mX < 31)) {Help$ = "Decrement Degrees/Step value."; return;}
    else if ((mX >= 31) && (mX < 81)) {Help$ = "Degrees/Step value used in step calcs. Click to reset."; return;}
    else if ((mX >= 81) && (mX <= 99)) {Help$ = "Increment Degrees/Step value."; return;}
    // Speed buttons and field
         if ((mX >= 722) && (mX < 740)) {Help$ = "Decrement Speed value."; return;}
    else if ((mX >= 740) && (mX < 791)) {Help$ = "Speed value (steps/sec). Click to reset to default."; return;}
    else if ((mX >= 791) && (mX <= 809)) {Help$ = "Increment Speed value."; return;}
  }
}

// ----------------------------------------------------------------------

void Help_Message_2() {
  // display help messages for Scrn2
  if (!CmdRow) {
    // not a command so do this
    if ((mY >= 99) && (mY <= 124)) {
      // RoboDog simulator image servo identification.
      // Maps image srvos to current row columns
      // Tier 3 servos
      if ((mX >= 272) && (mX <= 298)) {rowColPnt =  2; return;}  // FR3
      if ((mX >= 463) && (mX <= 489)) {rowColPnt =  8; return;}  // RR3
      if ((mX >= 325) && (mX <= 350)) {rowColPnt =  5; return;}  // FL3
      if ((mX >= 516) && (mX <= 542)) {rowColPnt = 11; return;}  // RL3
    }
    else if ((mY >= 171) && (mY < 196)) {
      // Tier 2 servos
      if ((mX >= 272) && (mX <= 298)) {rowColPnt =  1; return;}  // FR2
      if ((mX >= 463) && (mX <= 489)) {rowColPnt =  7; return;}  // RR2
      if ((mX >= 325) && (mX <= 350)) {rowColPnt =  4; return;}  // FL2
      if ((mX >= 516) && (mX <= 542)) {rowColPnt = 10; return;}  // RL2
    }
    // Tier 1 servos, areas move with leg drawing process
    if ((mY >= (HY0 - 11)) && (mY <= (HY0 + 11))) {  // FR1
      if ((mX >= (HX0 - 11)) && (mX <= (HX0 + 11))) {rowColPnt =  0; return;}
    }
    if ((mY >= (HY1 - 11)) && (mY <= (HY1 + 11))) {  // RR1
      if ((mX >= (HX1 - 11)) && (mX <= (HX1 + 11))) {rowColPnt =  3; return;}
    }
    if ((mY >= (HY2 - 11)) && (mY <= (HY2 + 11))) {  // FL1
      if ((mX >= (HX2 - 11)) && (mX <= (HX2 + 11))) {rowColPnt =  6; return;}
    }
    if ((mY >= (HY3 - 11)) && (mY <= (HY3 + 11))) {  // RL1
      if ((mX >= (HX3 - 11)) && (mX <= (HX3 + 11))) {rowColPnt =  9; return;}
    }
    drawFlag = 1;  // removes highlights when mouse moves off areas
  }
  
  // Calculation fields and buttons
  if ((mY >= 373) && (mY <= 532)) {
    if ((mX >= 103) && (mX <= 153)) {
      // 1st field column
           if ((mY >= 404) && (mY <= 431)) {Help$ = "Left legs max upper T2 servo angle.";}
      else if ((mY >= 436) && (mY <= 463)) {Help$ = "Calculated left steps value.";}
      else if ((mY >= 470) && (mY <= 497)) {Help$ = "Left legs max lower T1 servo angle.";}
      else if ((mY >= 503) && (mY <= 528)) {Help$ = "Calculated left side height.";}
    }
    if ((mX >= 272) && (mX <= 322)) {
      // 2nd field column
           if ((mY >= 404) && (mY <= 431)) {Help$ = "Left legs min upper T2 servo angle.";}
      else if ((mY >= 436) && (mY <= 463)) {Help$ = "Calculated upper T2 mid-point angle value.";}
      else if ((mY >= 470) && (mY <= 497)) {Help$ = "Left legs lower T1 servo lift angle.";}
    }
    
    if ((mX >= 352) && (mX <= 473)) {
      // centre controls - Link,transpose,Speed,Calc
      if (mY <= 407) {
        // Link button region
             if (mX < 377) {Help$ = "Copy right leg values to left leg.";}
        else if ((mX >= 377) && (mX <= 446)) {Help$ = "Link left and right leg values.";}
        else if (mX > 446) {Help$ = "Copy left leg values to right leg.";}
      }
      else if (mY <= 433) {
        // Transpose button
        if ((mX >= 399) && (mX <= 424)) {Help$ = "Transpose right and left leg settings.";}
      }
      if ((mY >= 454) && (mY <= 480)) {
        // Speed settings
             if ((mX >= 369) && (mX < 386)) {Help$ = "Decrement Speed value.";}
        else if ((mX >= 386) && (mX <= 438)) {Help$ = "Speed value.";}
        else if ((mX > 438) && (mX <= 455)) {Help$ = "Increment Speed value.";}
      }
      if ((mY >= 498) && (mY <= 532)) {
        // Calculate button
        if ((mX >= 377) && (mX < 447)) {Help$ = "Calculate a move table using current settings.";}
      }
    }
    
    if ((mX >= 567) && (mX <= 616)) {
     // 4th field column
          if ((mY >= 404) && (mY <= 431)) {Help$ = "Right legs max upper T2 servo angle.";}
     else if ((mY >= 436) && (mY <= 463)) {Help$ = "Calculated right steps value.";}
     else if ((mY >= 470) && (mY <= 497)) {Help$ = "Right legs max lower T1 servo angle.";}
     else if ((mY >= 503) && (mY <= 528)) {Help$ = "Calculated right side height.";}
   }
    if ((mX >= 737) && (mX <= 785)) {
      // 5th field column
           if ((mY >= 404) && (mY <= 431)) {Help$ = "Right legs min upper T2 servo angle.";}
      else if ((mY >= 436) && (mY <= 463)) {Help$ = "Calculated upper T2 mid-point angle value.";}
      else if ((mY >= 470) && (mY <= 497)) {Help$ = "Calculated right legs lower T1 servo lift angle.";}
    }
  }
}

// ----------------------------------------------------------------------
