
// ----------------------------------------------------------------------

void drawAngField() {
  // called to draw angle highlight boxes around angle fields and servos
  // Not used by Scrn 2 simulator screen
  if (AngField < 0) {return;}

  if (Scrn == 0) {
    stroke(255,80,80); noFill(); strokeWeight(4);
    if (AngField ==  0) {rect(286,385,48,24); return;}
    if (AngField ==  1) {rect(173,261,48,24); return;}
    if (AngField ==  2) {rect(148,122,48,24); return;}
    if (AngField ==  3) {rect(385,385,48,24); return;}
    if (AngField ==  4) {rect(275,261,48,24); return;}
    if (AngField ==  5) {rect(250,122,48,24); return;}
    if (AngField ==  6) {rect(512,385,48,24); return;}
    if (AngField ==  7) {rect(400,261,48,24); return;}
    if (AngField ==  8) {rect(376,122,48,24); return;}
    if (AngField ==  9) {rect(612,385,48,24); return;}
    if (AngField == 10) {rect(501,261,48,24); return;}
    if (AngField == 11) {rect(476,122,48,24); return;}
  } else {
    stroke(255,80,80); noFill(); strokeWeight(4);
    if (AngField ==  0) {rect(616,308,22,20); return;}  // FR1
    if (AngField ==  1) {rect(602,244,22,20); return;}  // FR2
    if (AngField ==  2) {rect(597,190,24,20); return;}  // FR3
    
    if (AngField ==  3) {rect(721,308,24,20); return;}  // FL1
    if (AngField ==  4) {rect(706,244,24,20); return;}  // FL2
    if (AngField ==  5) {rect(702,190,24,20); return;}  // FL3
    
    if (AngField ==  6) {rect(657,308,22,20); return;}  // RR1
    if (AngField ==  7) {rect(646,244,24,20); return;}  // RR2
    if (AngField ==  8) {rect(637,190,24,20); return;}  // RR3
    
    if (AngField ==  9) {rect(762,308,24,20); return;}  // RL1
    if (AngField == 10) {rect(748,244,24,20); return;}  // RL2
    if (AngField == 11) {rect(743,190,24,20); return;}  // RL3
  }
}

// ----------------------------------------------------------------------

void drawAngFill(int zX,int zY) {
  // draws a filled rectangle based on pre-determined fill colours
  stroke(AR,AG,AB); fill(AR,AG,AB); rect(zX+2,zY-1,26,18);
}

// ----------------------------------------------------------------------

void drawAngles() {
  // update servo angle value fields
  // servo array data is defined as:
  // SR0,SR1,SR2,SR3,SR4,SL0,SL1,SL2,SL3,SL4,Stp
  BR = 220; BG = 230; BB = 242;
  int zAng;
  int zAPnt = rowPnt * rowWidth;
  int zY1 = 391; int zY2 = 265; int zY3 = 128;
  if (ArrayVal[zAPnt] < 0) {return;}  // command so don't display angles

  // draw FR1
  TB = 255; TR = 0; zAng = getAngVal(ArrayVal[zAPnt]); if (AngRate) {TB = 0; TR = 255;}
  //drawTxtCtrField("       ", 311, zY1); 
  drawTxtCtrField(str(zAng) + "°", 311, zY1);
  if (!AngPwr) {stroke(0,0,0); fill(200,0,0); strokeWeight(1); circle(311,421,18);}

  // draw FR2
  zAPnt++;
  TB = 255; TR = 0; zAng = getAngVal(ArrayVal[zAPnt]); if (AngRate) {TB = 0; TR = 255;}
  //drawTxtCtrField("       ", 199, zY2);
  drawTxtCtrField(str(zAng) + "°", 199, zY2);
  if (!AngPwr) {stroke(0,0,0); fill(200,0,0); strokeWeight(1); circle(198,296,18);}

  // draw FR3
  zAPnt++;
  TB = 255; TR = 0; zAng = getAngVal(ArrayVal[zAPnt]); if (AngRate) {TB = 0; TR = 255;}
  //drawTxtCtrField("       ", 174, zY3);
  drawTxtCtrField(str(zAng) + "°", 174, zY3);
  if (!AngPwr) {stroke(0,0,0); fill(200,0,0); strokeWeight(1); circle(173,158,18);}

  // draw FL1
  zAPnt++;
  TB = 255; TR = 0; zAng = getAngVal(ArrayVal[zAPnt]); if (AngRate) {TB = 0; TR = 255;}
  //drawTxtCtrField("       ", 411, zY1);
  drawTxtCtrField(str(zAng) + "°", 411, zY1);
  if (!AngPwr) {stroke(0,0,0); fill(200,0,0); strokeWeight(1); circle(410,421,18);}

  // draw FL2
  zAPnt++;
  TB = 255; TR = 0; zAng = getAngVal(ArrayVal[zAPnt]); if (AngRate) {TB = 0; TR = 255;}
  //drawTxtCtrField("       ", 301, zY2);
  drawTxtCtrField(str(zAng) + "°", 301, zY2);
  if (!AngPwr) {stroke(0,0,0); fill(200,0,0); strokeWeight(1); circle(299,296,18);}

  // draw FL3
  zAPnt++;
  TB = 255; TR = 0; zAng = getAngVal(ArrayVal[zAPnt]); if (AngRate) {TB = 0; TR = 255;}
  //drawTxtCtrField("       ", 274, zY3);
  drawTxtCtrField(str(zAng) + "°", 274, zY3);
  if (!AngPwr) {stroke(0,0,0); fill(200,0,0); strokeWeight(1); circle(275,158,18);}

  // draw RR1
  zAPnt++;
  TB = 255; TR = 0; zAng = getAngVal(ArrayVal[zAPnt]); if (AngRate) {TB = 0; TR = 255;}
  //drawTxtCtrField("       ", 535, zY1);
  drawTxtCtrField(str(zAng) + "°", 535, zY1);
  if (!AngPwr) {stroke(0,0,0); fill(200,0,0); strokeWeight(1); circle(537,421,18);}

  // draw RR2
  zAPnt++;
  TB = 255; TR = 0; zAng = getAngVal(ArrayVal[zAPnt]); if (AngRate) {TB = 0; TR = 255;}
  //drawTxtCtrField("       ", 425, zY2);
  drawTxtCtrField(str(zAng) + "°", 425, zY2);
  if (!AngPwr) {stroke(0,0,0); fill(200,0,0); strokeWeight(1); circle(425,296,18);}

  // draw RR3
  zAPnt++;
  TB = 255; TR = 0; zAng = getAngVal(ArrayVal[zAPnt]); if (AngRate) {TB = 0; TR = 255;}
  //drawTxtCtrField("       ", 401, zY3);
  drawTxtCtrField(str(zAng) + "°", 401, zY3);
  if (!AngPwr) {stroke(0,0,0); fill(200,0,0); strokeWeight(1); circle(401,158,18);}

  // draw RL1
  zAPnt++;
  TB = 255; TR = 0; zAng = getAngVal(ArrayVal[zAPnt]); if (AngRate) {TB = 0; TR = 255;}
  //drawTxtCtrField("       ", 635, zY1);
  drawTxtCtrField(str(zAng) + "°", 635, zY1);
  if (!AngPwr) {stroke(0,0,0); fill(200,0,0); strokeWeight(1); circle(637,421,18);}

  // draw RL2
  zAPnt++;
  TB = 255; TR = 0; zAng = getAngVal(ArrayVal[zAPnt]); if (AngRate) {TB = 0; TR = 255;}
  //drawTxtCtrField("       ", 526, zY2);
  drawTxtCtrField(str(zAng) + "°", 526, zY2);
  if (!AngPwr) {stroke(0,0,0); fill(200,0,0); strokeWeight(1); circle(526,296,18);}

  // draw RL3
  zAPnt++;
  TB = 255; TR = 0; zAng = getAngVal(ArrayVal[zAPnt]); if (AngRate) {TB = 0; TR = 255;}
  //drawTxtCtrField("       ", 500, zY3);
  drawTxtCtrField(str(zAng) + "°", 500, zY3);
  if (!AngPwr) {stroke(0,0,0); fill(200,0,0); strokeWeight(1); circle(502,158,18);}
}

// ----------------------------------------------------------------------

void drawAngPos() {
  // overlays coloured semi-transparent boxes on the RoboDog image for the
  // current row values in Scrn1 only
  int zAPnt;
  if (HelpRowPnt < 0) {zAPnt = rowPnt * rowWidth;}
  else {zAPnt = HelpRowPnt * rowWidth;}
  if (ArrayVal[zAPnt] < 0) {return;}  // command line
  
  strokeWeight(1);  // applies to all boxes
  int zX;  // co-ordinate for rectangle
  int zY;  // co-ordinate for rectangle

  // FR1,RR1,FL1,RL1 at 70% transparency == 77 (0 = transparent, 255 = opaque)
  fill(255,67,67,120); stroke(255,67,67,120);
  zY = mapInt(getAngVal(ArrayVal[zAPnt]),0,160,337,424);    // FR1
  rect(614,zY,32,10);
  zY = mapInt(getAngVal(ArrayVal[zAPnt+3]),0,160,337,424);  // FL1
  rect(704,zY,32,10);
  zY = mapInt(getAngVal(ArrayVal[zAPnt+6]),0,160,337,424);  // RR1
  rect(654,zY,32,10);
  zY = mapInt(getAngVal(ArrayVal[zAPnt+9]),0,160,337,424);  // RL1
  rect(746,zY,32,10);

  // FR2,RR2,FL2,RL2 at 70% transparency == 77 (0 = transparent, 255 = opaque)
  fill(29,171,76,120); stroke(29,171,76,120);
  zY = mapInt(getAngVal(ArrayVal[zAPnt+1]),0,160,237,336);  // FR2
  rect(614,zY,32,10);
  zY = mapInt(getAngVal(ArrayVal[zAPnt+4]),0,160,237,336);  // FL2
  rect(704,zY,32,10);
  zY = mapInt(getAngVal(ArrayVal[zAPnt+7]),0,160,237,336);  // RR2
  rect(654,zY,32,10);
  zY = mapInt(getAngVal(ArrayVal[zAPnt+10]),0,160,237,336); // RL2
  rect(746,zY,32,10);

  // FR3,RR3,FL3,RL3 at 70% transparency == 77 (0 = transparent, 255 = opaque)
  fill(0,112,192,120); stroke(0,112,192,120);
  zX = mapInt(getAngVal(ArrayVal[zAPnt+2]),70,130,614,583);  // FR3
  rect(zX,184,10,32);
  zX = mapInt(getAngVal(ArrayVal[zAPnt+5]),50,110,729,698);  // FL3
  rect(zX,184,10,32);
  zX = mapInt(getAngVal(ArrayVal[zAPnt+8]),70,130,654,623);  // RR3
  rect(zX,184,10,32);
  zX = mapInt(getAngVal(ArrayVal[zAPnt+11]),50,110,769,738); // RL3
  rect(zX,184,10,32);
}

// ----------------------------------------------------------------------

void drawArrayRows() {
  // draw array data as a list of rows
  int zCX = 323;   // row left X co-ordinate
  int zDX = 150;   // row centre X co-ordinate
  int zPnt;        // row pointer
  //int zNL = 5;     // number of lines
  //int zLY = 607 - ((zNL/2) * 24);   // first row Y co-ordinate
  int zNL = 6;     // number of lines
  int zLY = 622 - ((zNL * 24)/2);   // first row Y co-ordinate
  String zR = "";  // temp row string
  int zRnX = 120;  // row number field X co-ordinate
  int zSlX = 518;  // steps field X co-ordinate 
  int zSP = 12;    // offset to array steps value
  if (Scrn == 1) {
    // list screen
    zNL = 27;      // number of lines
    zLY = 356 - ((zNL/2) * 24);  // first row Y co-ordinate
  }
  int zH0;
  if (Scrn != 1) {zH0 = (zNL/2) - rowPnt - 2;}
  else {zH0 = (zNL/2) - rowPnt - 1;}
  int zH1 = zH0 + rowNum + 1;

  getMinMaxAng();
  TR = 0; TG = 0; TB = 0;
  for (int zLP = 0; zLP < zNL; zLP++) {
    if ((zLP > zH0) && (zLP < zH1)) {
      int zRow = zLP - zH0 - 1;
      if (Select[zRow]) {BB = 60; BG = 255; BR = 255; Sel = true;} else {BB = 220; BG = 220; BR = 220; Sel = false;}
      zPnt =  zRow * rowWidth; TB = 0; TR = 0;
      drawTxtCtrField(str(zRow), zRnX, zLY);  // row number field
      drawRowValues(zPnt, zDX, zLY); TR = 0; TG = 0; TB = 0;
      drawTxtCtrField(getStrArrayVal(zPnt + zSP), 554, zLY);
      drawTxtField(Slope$,zSlX,zLY);  // Slope$ fields
    }
    else if ((zLP == zH0) || (zLP == zH1)) {
      // draw a header line
      BB = 220; BG = 220; BR = 220; TB = 0;
      drawTxtCtrField("--", zRnX, zLY);  // row number field
      drawTxtCtrField("FR1 FR2 FR3 FL1  FL2  FL3 RR1  RR2  RR3 RL1 RL2 RL3", zCX, zLY);
      drawTxtField("R", zSlX, zLY);  // Slope$ fields
      drawTxtCtrField("Stp", 554, zLY);
    }
    zLY += 24; TR = 0; TG = 0; TB = 0;
  }
  // reset text field backgrounds
  BB = 255; BG = 255; BR = 255;
}

// ----------------------------------------------------------------------

void drawColHighlight() {
  //draws a rectangle around the associated active row column
  int zX = 0; int zY = 592; if (Scrn == 1) {zY = 351;}
  switch (rowColPnt) {
    case  0: zX = 151; break;  // FR1
    case  1: zX = 180; break;  // FR2
    case  2: zX = 208; break;  // FR3
    case  3: zX = 237; break;  // FL1
    case  4: zX = 267; break;  // FL2
    case  5: zX = 294; break;  // FL3
    case  6: zX = 323; break;  // RR1
    case  7: zX = 353; break;  // RR2
    case  8: zX = 381; break;  // RR3
    case  9: zX = 409; break;  // RL1
    case 10: zX = 440; break;  // RL2
    case 11: zX = 467; break;  // RL3
    default: return;
  }
  stroke(255,0,255); noFill(); strokeWeight(4); rect(zX,zY,29,27);
}

// ----------------------------------------------------------------------

void drawCOMMsg() {
  // put text in COM value field
  if (comFlag < 1) {TR = 255;}
  drawTxtField(msgCOM, 120, 697); TR = 0;
}

// ----------------------------------------------------------------------

void drawDegSteps() {
  // put Degrees/Step value in text field
  TB = 255; BR = 255; BG = 255; BB = 255;
  //drawTxtCtrField("    ", 55, 520);
  drawTxtCtrField(str(DegStep), 55, 520);
}

// ----------------------------------------------------------------------

void drawEchoLamp() {
  // draws a lamp within the Echo button
  strokeWeight(1);
  if (Echo) {
    // echo is ON
    stroke(80,120,255); fill(80,120,255);
  } else {
    // echo is OFF
    stroke(255,255,255); fill(255,255,255);
  } rect(791,695,8,17);
}

// ----------------------------------------------------------------------

void drawHelp() {
  // display help messages
  TB = 255; drawTxtCtrField(Help$, 408, 729);
}

// ----------------------------------------------------------------------

void drawHidden() {
  // effectively hides features which are not always accessible
  stroke(191,191,191); fill(191,191,191); strokeWeight(1);
  //stroke(191,0,0); fill(191,0,0); strokeWeight(1);  // for test
  
  // X,Y co-ordinates are defined as:
  // Col 0 =   8, Col 1 =  40, Col 2 =  71
  // Row 0 = 542, Row 1 = 579, Row 2 = 616, Row 3 = 653
  
  // always hide these unused buttons
  rect( 8,542,30,36);  // col 0, row 0, Nop
  rect(40,542,30,36);  // col 1, row 0, Nop
  rect( 8,653,30,36);  // col 0, row 3, Nop
  
  if (SelCnt < 1) {
    // no rows are selected
    // hide shift, cut, paste, step and transform keys
    rect(71,542,31,36);  // col 2, row 0, Up arrow
    rect( 8,579,30,36);  // col 0, row 1, Cut
    rect(40,579,30,36);  // col 1, row 1, Copy
    rect( 8,616,30,36);  // col 0, row 2, Goto
    rect(40,616,30,36);  // col 1, row 2, Steps
    rect(71,616,31,36);  // col 2, row 2, Transpose
    rect(40,653,30,36);  // col 1, row 3, Reverse order
    rect(71,653,31,36);  // col 2, row 3, Down arrow
  }
  if (CopyCnt < 1) {
    // nothing has been copied
    // this hides the Paste button if nothing has been copied
    if (SelCnt < 1) {
      // no rows are selected
      rect(71,579,31,36);  // col 2, row 1, Paste
    }
  }
  if (!usbEn && (Scrn != 2)) {
    // hide play, repeat, pause, stop buttons when in Scrn0 and the
    // USB port messaging is not enabled
    rect(690,597,117,36);
  }
}

// ----------------------------------------------------------------------

void drawLinks() {
  // if link flags are set draw boxes around buttons
  if (ArrayVal[rowPnt * rowWidth] < 0) {return;}  // command so don't draw angles

  stroke(255,80,80); noFill();
  strokeWeight(3);
  if (Link[FR3] > 0) {rect(213,121,22,29);}
  if (Link[FR3] > 1) {rect(326,124,29,22);}  // multi-link
  if (Link[RR3] > 0) {rect(439,121,22,29);}
  if (Link[FR2] > 0) {rect(238,259,22,29);}
  if (Link[FR2] > 1) {rect(352,262,29,22);}  // multi-link
  if (Link[RR2] > 0) {rect(465,259,22,30);}
  if (Link[FR1] > 0) {rect(350,383,22,30);}
  if (Link[FR1] > 1) {rect(462,386,29,22);}  // multi-link
  if (Link[RR1] > 0) {rect(576,383,22,30);}
}

// ----------------------------------------------------------------------

void drawMemBars() {
  // colour in memory bars if data is stored
  stroke(80,200,220); fill(80,200,220); strokeWeight(1);
  if (M0 > 0) {rect(697,565,16,4);}
  if (M1 > 0) {rect(726,565,16,4);}
  if (M2 > 0) {rect(755,565,16,4);}
  if (M3 > 0) {rect(784,565,16,4);}
}

// ----------------------------------------------------------------------

void drawMouseXY() {
  // draws the value of mouse x,y top left
  // draws a full X/Y axis on the form
  if ((mX != mXL) || (mY != mYL)) {
    // draw full X/Y axis
    stroke(255,0,0,128); strokeWeight(1);
    line(0,mY,823,mY); line(mX,0,mX,759);

    int zX,zY;
    if (mX > 412) {zX = mX - 58;} else {zX = mX + 8;}
    if (mY > 380) {zY = mY - 38;} else {zY = mY + 8;}
    stroke(0,0,0); fill(255,255,255); rect(zX,zY,50,30);
    fill(0,0,0); text("X=" + mX, zX + 4, zY + 13); text("Y=" + mY, zX + 4, zY + 27);
    mXL = mX; mYL = mY;
  }
}

// ----------------------------------------------------------------------

void drawRates() {
  // fill in the 'Rate' buttons, faint or in RED
  int zAPnt = rowPnt * rowWidth;
  if (ArrayVal[zAPnt] < 0) {return;}  // command so don't display angle rates

  // FR1
  fill (120,120,120);if (ArrayVal[zAPnt] >= 400) {fill (255,60,60);}
  text("R",289,424); zAPnt++;

  // FR2
  fill (120,120,120);if (ArrayVal[zAPnt] >= 400) {fill (255,60,60);}
  text("R",177,299); zAPnt++;

  // FR3
  fill (120,120,120);if (ArrayVal[zAPnt] >= 400) {fill (255,60,60);}
  text("R",186,162); zAPnt++;

  // FL1
  fill (120,120,120);if (ArrayVal[zAPnt] >= 400) {fill (255,60,60);}
  text("R",388,424); zAPnt++;

  // FL2
  fill (120,120,120);if (ArrayVal[zAPnt] >= 400) {fill (255,60,60);}
  text("R",278,299); zAPnt++;

  // FL3
  fill (120,120,120);if (ArrayVal[zAPnt] >= 400) {fill (255,60,60);}
  text("R",288,162); zAPnt++;

  // RR1
  fill (120,120,120);if (ArrayVal[zAPnt] >= 400) {fill (255,60,60);}
  text("R",515,424); zAPnt++;

  // RR2
  fill (120,120,120);if (ArrayVal[zAPnt] >= 400) {fill (255,60,60);}
  text("R",403,299); zAPnt++;

  // RR3
  fill (120,120,120);if (ArrayVal[zAPnt] >= 400) {fill (255,60,60);}
  text("R",413,162); zAPnt++;

  // RL1
  fill (120,120,120);if (ArrayVal[zAPnt] >= 400) {fill (255,60,60);}
  text("R",615,424); zAPnt++;

  // RL2
  fill (120,120,120);if (ArrayVal[zAPnt] >= 400) {fill (255,60,60);}
  text("R",504,299); zAPnt++;

  // RL3
  fill (120,120,120);if (ArrayVal[zAPnt] >= 400) {fill (255,60,60);}
  text("R",514,162); zAPnt++;
}

// ----------------------------------------------------------------------

void drawRowValues(int zPnt,int zDX,int zLY) {
  // draw a line of row angles in the list, with formatting
  int zAng;
  int zCP = 0;  // array column pointer
  String zV$ = "";
  Cmd = false; Blank = false; Slope$ = "C";
  
  // FR1 or Cmd
  if (Cmd) {zAng = ArrayVal[zPnt];} else {zAng = getAngVal(ArrayVal[zPnt]);}
  zPnt++;
  getAngFillCol(zAng,zCP); zCP++;  // determine the background fill colour
  if (zAng < 0) {
    Cmd = true;
    zAng = ArrayVal[zPnt];    // already pointing at next value
    Blank = true; Slope$ = "   ";
         if (zAng == 0) {return;}  // blank line command
    else if (zAng < 6) {zV$ = "cmd";}
    else {zV$ = "exe";}
  } else {
    zV$ = str(zAng);
    if (zAng < 100) {zV$ = "  " + zV$;}
    if (zAng < 10) {zV$ = "  " + zV$;}
  }
  if (AngRate || Cmd) {TR = 190;} else {TR = 0;}
  if (Sel) {drawTxtField(zV$,zDX,zLY);}
  else {
    if (!Cmd) {drawAngFill(zDX,zLY);}
    drawTxtNF(zV$,zDX,zLY);
  }
  if (Cmd) {Sel = false;}

  zDX += 28;  // FR2 or CmdCode
  if (Cmd) {zAng = ArrayVal[zPnt];} else {zAng = getAngVal(ArrayVal[zPnt]);}
  zPnt++;
  getAngFillCol(zAng,zCP); zCP++;  // determine the background fill colour
  zV$ = str(zAng); CmdCode = zAng;
  if (zAng < 100) {zV$ = "  " + zV$;}
  if (zAng < 10) {zV$ = "  " + zV$;}
  if (AngRate || Cmd) {TR = 190;} else {TR = 0;}
  if (Sel) {drawTxtField(zV$,zDX,zLY);}
  else {
    if (!Cmd) {drawAngFill(zDX,zLY);}
    drawTxtNF(zV$,zDX,zLY);
  }

  zDX += 29;  // FR3 or CmdVal0
  if (Cmd) {zAng = ArrayVal[zPnt];} else {zAng = getAngVal(ArrayVal[zPnt]);}
  zPnt++;
  getAngFillCol(zAng,zCP); zCP++;  // determine the background fill colour
  zV$ = str(zAng); CmdVal0 = zAng;
  if (zAng < 100) {zV$ = "  " + zV$;}
  if (zAng < 10) {zV$ = "  " + zV$;}
  if (AngRate || Cmd) {TR = 190;} else {TR = 0;}
  if (Sel) {drawTxtField(zV$,zDX,zLY);}
  else {
    if (!Cmd) {drawAngFill(zDX,zLY);}
    drawTxtNF(zV$,zDX,zLY);
  }

  zDX += 29;  // FL1
  zAng = getAngVal(ArrayVal[zPnt]); zPnt++;
  getAngFillCol(zAng,zCP); zCP++;  // determine the background fill colour
  if (Cmd && (zAng == 0)) {
    switch(CmdCode) {
      case 1: zV$ = " Goto row " + str(CmdVal0); break;
      case 2: zV$ = " Set Speed to " + str(CmdVal0); break;
      case 3: zV$ = "  Pause for " + str(CmdVal0) + " step"; if (CmdVal0 > 1) {zV$ += "s";} break;
      case 4: zV$ = " Set Flag to " + str(CmdVal0); break;
      case 5: zV$ = " Set Balance to ";
             if (CmdVal0 == 0) {zV$+= "OFF";}
        else if (CmdVal0 == 1) {zV$+= "topple only";}
        else if (CmdVal0 == 2) {zV$+= "balance only";}
        else if (CmdVal0 == 3) {zV$+= "topple and balance";}
        break;
      case 6: zV$ = " For...1 to  ..." + str(CmdVal0) + " loop"; break;
      case 7: zV$ = " Next after a For... loop"; break;
    } drawTxtNF(zV$,zDX,zLY);
    return;
  } else {
    zV$ = str(zAng);
    if (zAng < 100) {zV$ = "  " + zV$;}
    if (zAng < 10) {zV$ = "  " + zV$;}
  } 
  if (AngRate || Cmd) {TR = 190;} else {TR = 0;}
  if (Sel) {drawTxtField(zV$,zDX,zLY);}
  else {
    if (!Cmd) {drawAngFill(zDX,zLY);}
    drawTxtNF(zV$,zDX,zLY);
  }

  zDX += 29;  // FL2
  zAng = getAngVal(ArrayVal[zPnt]); zPnt++;
  getAngFillCol(zAng,zCP); zCP++;  // determine the background fill colour
  zV$ = str(zAng);
  if (zAng < 100) {zV$ = "  " + zV$;}
  if (zAng < 10) {zV$ = "  " + zV$;}
  if (AngRate || Cmd) {TR = 190;} else {TR = 0;}
  if (Sel) {drawTxtField(zV$,zDX,zLY);}
  else {
    if (!Cmd) {drawAngFill(zDX,zLY);}
    drawTxtNF(zV$,zDX,zLY);
  }

  zDX += 28;  // FL3
  zAng = getAngVal(ArrayVal[zPnt]); zPnt++;
  getAngFillCol(zAng,zCP); zCP++;  // determine the background fill colour
  zV$ = str(zAng);
  if (zAng < 100) {zV$ = "  " + zV$;}
  if (zAng < 10) {zV$ = "  " + zV$;}
  if (AngRate || Cmd) {TR = 190;} else {TR = 0;}
  if (Sel) {drawTxtField(zV$,zDX,zLY);}
  else {
    if (!Cmd) {drawAngFill(zDX,zLY);}
    drawTxtNF(zV$,zDX,zLY);
  }

  zDX += 29;  // RR1
  zAng = getAngVal(ArrayVal[zPnt]); zPnt++;
  getAngFillCol(zAng,zCP); zCP++;  // determine the background fill colour
  zV$ = str(zAng);
  if (zAng < 100) {zV$ = "  " + zV$;}
  if (zAng < 10) {zV$ = "  " + zV$;}
  if (AngRate || Cmd) {TR = 190;} else {TR = 0;}
  if (Sel) {drawTxtField(zV$,zDX,zLY);}
  else {
    if (!Cmd) {drawAngFill(zDX,zLY);}
    drawTxtNF(zV$,zDX,zLY);
  }

  zDX += 29;  // RR2
  zAng = getAngVal(ArrayVal[zPnt]); zPnt++;
  getAngFillCol(zAng,zCP); zCP++;  // determine the background fill colour
  zV$ = str(zAng);
  if (zAng < 100) {zV$ = "  " + zV$;}
  if (zAng < 10) {zV$ = "  " + zV$;}
  if (AngRate || Cmd) {TR = 190;} else {TR = 0;}
  if (Sel) {drawTxtField(zV$,zDX,zLY);}
  else {
    if (!Cmd) {drawAngFill(zDX,zLY);}
    drawTxtNF(zV$,zDX,zLY);
  }

  zDX += 29;  // RR3
  zAng = getAngVal(ArrayVal[zPnt]); zPnt++;
  getAngFillCol(zAng,zCP); zCP++;  // determine the background fill colour
  zV$ = str(zAng);
  if (zAng < 100) {zV$ = "  " + zV$;}
  if (zAng < 10) {zV$ = "  " + zV$;}
  if (AngRate || Cmd) {TR = 190;} else {TR = 0;}
  if (Sel) {drawTxtField(zV$,zDX,zLY);}
  else {
    if (!Cmd) {drawAngFill(zDX,zLY);}
    drawTxtNF(zV$,zDX,zLY);
  }

  zDX += 29;  // RL1
  zAng = getAngVal(ArrayVal[zPnt]); zPnt++;
  getAngFillCol(zAng,zCP); zCP++;  // determine the background fill colour
  zV$ = str(zAng);
  if (zAng < 100) {zV$ = "  " + zV$;}
  if (zAng < 10) {zV$ = "  " + zV$;}
  if (AngRate || Cmd) {TR = 190;} else {TR = 0;}
  if (Sel) {drawTxtField(zV$,zDX,zLY);}
  else {
    if (!Cmd) {drawAngFill(zDX,zLY);}
    drawTxtNF(zV$,zDX,zLY);
  }

  zDX += 29;  // RL2
  zAng = getAngVal(ArrayVal[zPnt]); zPnt++;
  getAngFillCol(zAng,zCP); zCP++;  // determine the background fill colour
  zV$ = str(zAng);
  if (zAng < 100) {zV$ = "  " + zV$;}
  if (zAng < 10) {zV$ = "  " + zV$;}
  if (AngRate || Cmd) {TR = 190;} else {TR = 0;}
  if (Sel) {drawTxtField(zV$,zDX,zLY);}
  else {
    if (!Cmd) {drawAngFill(zDX,zLY);}
    drawTxtNF(zV$,zDX,zLY);
  }

  zDX += 28;  // RL3
  zAng = getAngVal(ArrayVal[zPnt]); zPnt++;
  getAngFillCol(zAng,zCP); zCP++;  // determine the background fill colour
  zV$ = str(zAng);
  if (zAng < 100) {zV$ = "  " + zV$;}
  if (zAng < 10) {zV$ = "  " + zV$;}
  if (AngRate || Cmd) {TR = 190;} else {TR = 0;}
  if (Sel) {drawTxtField(zV$,zDX,zLY);}
  else {
    if (!Cmd) {drawAngFill(zDX,zLY);}
    drawTxtNF(zV$,zDX,zLY);
  }
}

// ----------------------------------------------------------------------

void drawRxMsg() {
  // put text in the Rx field
  TB = 255;
  //drawTxtField("                                                    ", 223, 697);
  drawTxtField(msgRx, 223, 697);
}

// ----------------------------------------------------------------------

void drawSpeed() {
  // put Speed value in text field
  TB = 255;
  //drawTxtCtrField("    ", 766, 520);
  drawTxtCtrField(str(Speed), 766, 520);
}

// ----------------------------------------------------------------------

void drawTxtCtrField(String zM,int zX, int zY) {
  // called by other draw text functions. This centres the text around zX
  zX = zX - (int)(textWidth(zM)/2.0);
  stroke(BR,BG,BB); fill(BR,BG,BB); 
  rect(zX, zY, textWidth(zM), 15);
  fill(TR,TG,TB); text(zM, zX, zY+12);
}

// ----------------------------------------------------------------------

void drawTxtField(String zM,int zX, int zY) {
  // called by other draw text functions
  stroke(242,242,242); fill(BR,BG,BB); 
  rect(zX, zY, textWidth(zM) + 2, 14);
  fill(TR,TG,TB); text(zM, zX+4, zY+12);
}

// ----------------------------------------------------------------------

void drawTxMsg() {
  // put text in Tx field
  if (msgTx.length() > 27) {msgTx = msgTx.substring(0,23) + "...";}
  if (usbEn) {TR = 255; TG = 0; TB = 0;}
  else {TR = 30; TG = 30; TB = 30;}
  //drawTxtField("                                              ", 486, 697);
  drawTxtField(msgTx, 486, 697);

  noFill(); 
  if (usbEn) {
    if (usbOnCnt >= 10) {
      stroke(255,80,80); strokeWeight(4); rect(477,689,206,30);
    }
  }
  else {
    stroke(80,255,80); strokeWeight(3); rect(477,689,206,30);  // green box
  } TR = 0; TG = 0; TB = 0;
}

// ----------------------------------------------------------------------

void drawTxtNF(String zM,int zX, int zY) {
  // draws text without a filled background
  fill(TR,TG,TB); text(zM, zX+4, zY+12);
}

// ----------------------------------------------------------------------

void drawTxRxTime() {
  // display the Tx_t1 - Tx_t0 time
  if (Tx_t1 > 999) {Tx_t1 = 999;}  // limit output to 1 second
  TB = 0; drawTxtField(str(Tx_t1), 718, 696);
}

// ----------------------------------------------------------------------

void drawUsbLamp() {
  // draws a lamp next to the Tx field to indicate usb transmissions
  strokeWeight(1);
  if (usbLen > 0) {
    stroke(255,80,80); fill(255,80,80);
  } else if (RxB > 0) {
    stroke(80,255,80); fill(80,255,80);
  } else {
    stroke(255,255,255); fill(255,255,255);
  } rect(698,695,10,18);
}

// ----------------------------------------------------------------------

void drawWalkAngles() {
  // update left and right Walk Trainer angle value fields
  // draw first blue text fields on light blue
  BR = 220; BG = 230; BB = 242;
  TR = 0; TG = 0; TB = 255;
  int zY0 = 410;
  // T2maxAngLft
  //drawTxtCtrField("       ", 128, zY0);
  drawTxtCtrField(str(T2maxAngLft) + "°", 128, zY0);
  // T2minAngLft
  //drawTxtCtrField("       ", 298, zY0);
  drawTxtCtrField(str(T2minAngLft) + "°", 298, zY0);
  // T2maxAngRht
  //drawTxtCtrField("       ", 591, zY0);
  drawTxtCtrField(str(T2maxAngRht) + "°", 591, zY0);
  // T2minAngRht
  //drawTxtCtrField("       ", 762, zY0);
  drawTxtCtrField(str(T2minAngRht) + "°", 762, zY0);

  // T1maxAngLft
  zY0 = 477;
  //drawTxtCtrField("       ", 128, zY0);
  drawTxtCtrField(str(T1maxAngLft) + "°", 128, zY0);
  // T1 Lift
  //drawTxtCtrField("       ", 298, zY0);
  drawTxtCtrField(str(WalkLift), 298, zY0);
  // T1maxAngRht
  //drawTxtCtrField("       ", 591, zY0);
  drawTxtCtrField(str(T1maxAngRht) + "°", 591, zY0);


  // draw calc. black text fields light grey
  BR = 191; BG = 191; BB = 191;
  TR = 0; TG = 0; TB = 0;
  // CalcNomStepsLft
  zY0 = 443;
  //drawTxtCtrField("       ", 128, zY0);
  drawTxtCtrField(str(CalcNomStepsLft), 128, zY0);
  // CalcMidT2AngLft
  //drawTxtCtrField("       ", 298, zY0);
  drawTxtCtrField(str(T2midAngLft), 298, zY0);
  // CalcNomStepsRht
  //drawTxtCtrField("       ", 591, zY0);
  drawTxtCtrField(str(CalcNomStepsRht), 591, zY0);
  // CalcMidT2AngRht
  //drawTxtCtrField("       ", 762, zY0);
  drawTxtCtrField(str(T2midAngRht), 762, zY0);

  // Walk lift
  zY0 = 477;
  //drawTxtCtrField("       ", 762, zY0);
  drawTxtCtrField(str(WalkLift), 762, zY0);

  // CalcMaxHgtLft
  zY0 = 509;
  //drawTxtCtrField("       ", 128, zY0);
  drawTxtCtrField(str(CalcMaxHgtLft), 128, zY0);
  // CalcMaxHgtRht
  //drawTxtCtrField("       ", 591, zY0);
  drawTxtCtrField(str(CalcMaxHgtRht), 591, zY0);

  // draw black text fields white background
  // Speed adjust
  BR = 255; BG = 255; BB = 255;
  zY0 = 460;
  //drawTxtCtrField("       ", 412, zY0);
  drawTxtCtrField(str(Speed), 412, zY0);
}

// ----------------------------------------------------------------------

void drawWalkLegs() {
  // called in Scrn 2 mode to draw legs onto the robots image
  int zAPnt;
  if (HelpRowPnt < 0) {zAPnt = rowPnt * rowWidth;}  // get array pointer to FR1
  else {zAPnt = HelpRowPnt * rowWidth; HelpRowPnt = -1;}
  float zAng = 0.0;  // any angle in degrees
  float zRad = 0.0;  // any angle in radians
  float zSL = 30.0;  // length of shoulder spigots
  float zUL = 67.0;  // length of upper leg in pixels
  float zLL = 93.0;  // length of lower leg in pixels
  // check for command line
  if (ArrayVal[zAPnt] < 0) {return;}
  
  // draw ground line
  stroke(190,190,190); line(230,GndY,560,GndY);
  GndYM = 0;  // reset the max dynamic Y reference
  
  // draw FR3
  DX0 = 285; DY0 = 112;
  if (AngField != 2) {stroke(50,50,140); fill(50,50,140);} else {stroke(140,160,255); fill(140,160,255);}
  strokeWeight(1); circle(DX0,DY0,26);
  zAng = (float)getAngVal(ArrayVal[zAPnt + 2]); zRad = zAng /57.2958;
  DX1 = DX0 + int(zSL * cos(zRad)); DY1 = DY0 + int(zSL * sin(zRad));
  strokeWeight(10); line(DX0,DY0,DX1,DY1);
  // draw FR2
  DX0 = 285; DY0 = 184;
  if (AngField != 1) {stroke(0,90,0); fill(0,90,0);} else {stroke(0,255,0); fill(0,255,0);} 
  strokeWeight(1); circle(DX0,DY0,26);
  zAng = (float)getAngVal(ArrayVal[zAPnt + 1]); zRad = zAng /57.2958;
  DX1 = DX0 + int(zUL * cos(zRad)); DY1 = DY0 + int(zUL * sin(zRad));
  strokeWeight(8);
  line(DX0,DY0,DX1,DY1); line(DX0 - 8,DY0,DX1 - 4,DY1); line(DX0 + 8,DY0,DX1 + 4,DY1); DY1 +=8;
  // draw FR1
  if (AngField != 0) {stroke(90,0,0); fill(90,0,0);} else {stroke(255,0,0); fill(255,0,0);} 
  strokeWeight(1); circle(DX1,DY1,24);
  HX0 = DX1; HY0 = DY1;
  zAng = zAng + 180.0 - (float)getAngVal(ArrayVal[zAPnt]); zRad = zAng /57.2958;
  DX0 = DX1 + int(zLL * cos(zRad)); DY0 = DY1 + int(zLL * sin(zRad));
  strokeWeight(10); line(DX1,DY1,DX0,DY0);
  // draw foot
  fill(30,30,30); strokeWeight(1); circle(DX0,DY0,24);
  if (DY0 > GndYM) {GndYM = DY0;}
  
  // draw FL3
  DX0 = 338; DY0 = 112;
  if (AngField != 5) {stroke(120,120,210); fill(120,120,210);} else {stroke(190,190,255); fill(190,190,255);}
  strokeWeight(1); circle(DX0,DY0,26);
  zAng = (float)getAngVal(ArrayVal[zAPnt + 5]); zRad = zAng /57.2958;
  DX1 = DX0 + int(zSL * cos(zRad)); DY1 = DY0 + int(zSL * sin(zRad));
  strokeWeight(10); line(DX0,DY0,DX1,DY1);
  // draw FL2
  DX0 = 338; DY0 = 184;
  if (AngField != 4) {stroke(0,160,0); fill(0,160,0);} else {stroke(0,255,0); fill(0,255,0);} 
  strokeWeight(1); circle(DX0,DY0,26);
  zAng = (float)getAngVal(ArrayVal[zAPnt + 4]); zRad = zAng /57.2958;
  DX1 = DX0 + int(zUL * cos(zRad)); DY1 = DY0 + int(zUL * sin(zRad));
  strokeWeight(8);
  line(DX0,DY0,DX1,DY1); line(DX0 - 8,DY0,DX1 - 4,DY1); line(DX0 + 8,DY0,DX1 + 4,DY1); DY1 +=8;
  // draw FL1
  if (AngField != 3) {stroke(160,0,0); fill(160,0,0);} else {stroke(255,0,0); fill(255,0,0);} 
  strokeWeight(1); circle(DX1,DY1,24);
  HX1 = DX1; HY1 = DY1;
  zAng = zAng + 180.0 - (float)getAngVal(ArrayVal[zAPnt + 3]); zRad = zAng /57.2958;
  DX0 = DX1 + int(zLL * cos(zRad)); DY0 = DY1 + int(zLL * sin(zRad));
  strokeWeight(10); line(DX1,DY1,DX0,DY0);
  // draw foot
  fill(110,110,110); strokeWeight(1); circle(DX0,DY0,24);
  if (DY0 > GndYM) {GndYM = DY0;}
  
  // draw RR3
  DX0 = 476; DY0 = 112;
  if (AngField != 8) {stroke(50,50,140); fill(50,50,140);} else {stroke(140,160,255); fill(140,160,255);}
  strokeWeight(1); circle(DX0,DY0,26);
  zAng = (float)getAngVal(ArrayVal[zAPnt + 8]); zRad = zAng /57.2958;
  DX1 = DX0 + int(zSL * cos(zRad)); DY1 = DY0 + int(zSL * sin(zRad));
  strokeWeight(10); line(DX0,DY0,DX1,DY1);
  // draw RR2
  DX0 = 476; DY0 = 184;
  if (AngField != 7) {stroke(0,90,0); fill(0,90,0);} else {stroke(0,255,0); fill(0,255,0);} 
  strokeWeight(1); circle(DX0,DY0,26);
  zAng = (float)getAngVal(ArrayVal[zAPnt + 7]); zRad = zAng /57.2958;
  DX1 = DX0 + int(zUL * cos(zRad)); DY1 = DY0 + int(zUL * sin(zRad));
  strokeWeight(8);
  line(DX0,DY0,DX1,DY1); line(DX0 - 8,DY0,DX1 - 4,DY1); line(DX0 + 8,DY0,DX1 + 4,DY1); DY1 +=8;
  // draw RR1
  if (AngField != 6) {stroke(90,0,0); fill(90,0,0);} else {stroke(255,0,0); fill(255,0,0);} 
  strokeWeight(1); circle(DX1,DY1,24);
  HX2 = DX1; HY2 = DY1;
  zAng = zAng + 180.0 - (float)getAngVal(ArrayVal[zAPnt + 6]); zRad = zAng /57.2958;
  DX0 = DX1 + int(zLL * cos(zRad)); DY0 = DY1 + int(zLL * sin(zRad));
  strokeWeight(10); line(DX1,DY1,DX0,DY0);
  // draw foot
  fill(30,30,30); strokeWeight(1); circle(DX0,DY0,24);
  if (DY0 > GndYM) {GndYM = DY0;}
  
  // draw RL3
  DX0 = 529; DY0 = 112;
  if (AngField != 11) {stroke(120,120,210); fill(120,120,210);} else {stroke(190,190,255); fill(190,190,255);}
  strokeWeight(1); circle(DX0,DY0,26);
  zAng = (float)getAngVal(ArrayVal[zAPnt + 11]); zRad = zAng /57.2958;
  DX1 = DX0 + int(zSL * cos(zRad)); DY1 = DY0 + int(zSL * sin(zRad));
  strokeWeight(10); line(DX0,DY0,DX1,DY1);
  // draw RL2
  DX0 = 529; DY0 = 184;
  if (AngField != 10) {stroke(0,160,0); fill(0,160,0);} else {stroke(0,255,0);fill(0,255,0);} 
  strokeWeight(1); circle(DX0,DY0,26);
  zAng = (float)getAngVal(ArrayVal[zAPnt + 10]); zRad = zAng /57.2958;
  DX1 = DX0 + int(zUL * cos(zRad)); DY1 = DY0 + int(zUL * sin(zRad));
  strokeWeight(8);
  line(DX0,DY0,DX1,DY1); line(DX0 - 8,DY0,DX1 - 4,DY1); line(DX0 + 8,DY0,DX1 + 4,DY1); DY1 +=8;
  // draw RL1
  if (AngField != 9) {stroke(160,0,0); fill(160,0,0);} else {stroke(255,0,0); fill(255,0,0);} 
  strokeWeight(1); circle(DX1,DY1,24);
  HX3 = DX1; HY3 = DY1;
  zAng = zAng + 180.0 - (float)getAngVal(ArrayVal[zAPnt + 9]); zRad = zAng /57.2958;
  DX0 = DX1 + int(zLL * cos(zRad)); DY0 = DY1 + int(zLL * sin(zRad));
  strokeWeight(10); line(DX1,DY1,DX0,DY0);
  // draw foot
  fill(110,110,110); strokeWeight(1); circle(DX0,DY0,24);
  if (DY0 > GndYM) {GndYM = DY0;}
}

// ----------------------------------------------------------------------
